package net.bonotown.android.aravadebo;

import java.io.ByteArrayOutputStream;

import android.app.ListActivity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;

public class CameraActivity extends ListActivity {
	static final int REQUEST_IMAGE_CAPTURE = 1;
	static final int REQUEST_VIDEO_CAPTURE = 2;

	private double latitut;
	private double longitut;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_camera);

		Intent parentIntent = getIntent();

		Boolean esVideo = parentIntent.getBooleanExtra("esVideo", false);

		latitut = parentIntent.getDoubleExtra("latitude", 40.0010061);
		longitut = parentIntent.getDoubleExtra("longitude", 3.8365123);

		Intent takePictureIntent = new Intent((esVideo) ? MediaStore.ACTION_VIDEO_CAPTURE : MediaStore.ACTION_IMAGE_CAPTURE );

		if (takePictureIntent.resolveActivity(getPackageManager()) != null) {
			if (!esVideo) {
				startActivityForResult(takePictureIntent, REQUEST_IMAGE_CAPTURE);
			} else {
				startActivityForResult(takePictureIntent, REQUEST_VIDEO_CAPTURE);
			}
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_OK) {
			
			switch (requestCode) {
			case REQUEST_IMAGE_CAPTURE:
				Bundle bundle = data.getExtras();
				Bitmap takenPhoto = (Bitmap) bundle.get("data");
				
				ByteArrayOutputStream stream = new ByteArrayOutputStream();
				takenPhoto.compress(Bitmap.CompressFormat.PNG, 100, stream);
				byte[] byteArray = stream.toByteArray();

				Intent imatgeIntent = new Intent(CameraActivity.this, PostFotoActivity.class);
				imatgeIntent.putExtra("latitude", latitut);
				imatgeIntent.putExtra("longitude", longitut);
				imatgeIntent.putExtra("foto", byteArray);

				startActivity(imatgeIntent);
				
				break;

			case REQUEST_VIDEO_CAPTURE:
				Uri uriVideo = data.getData();

				Intent videoIntent = new Intent(CameraActivity.this, PostVideoActivity.class);

				videoIntent.putExtra("latitude", latitut);
				videoIntent.putExtra("longitude", longitut);
				videoIntent.setDataAndType(uriVideo, "video/*");

				startActivity(videoIntent);
			default:
				break;
			}

			finish();
		}
	}	
}
