package net.bonotown.android.aravadebo;

import java.text.ParseException;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;

import net.bonotown.android.aravadebo.adapter.GridViewCalendariAdapter;
import net.bonotown.android.aravadebo.adapter.LlistaAgendaAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaAgenda;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.GridView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class FragmentAgenda extends Fragment {
	//Definim variables globals
	private TextView titol_dia;
	private GridView calendariView;
	private ListView esdevenimentsView;
	private GridViewCalendariAdapter adapter;
	private Calendar calendari;
	private int mes, any;
	
	// constructor del fragment
	public FragmentAgenda() {}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		View rootView = inflater.inflate(R.layout.fragment_agenda, container, false);

		// inicialitzem el calendari segons la localització de l'usuari
		calendari = Calendar.getInstance(Locale.getDefault());
		mes = 6; //les festes són només durant uns dies del mes de juny
		any = calendari.get(Calendar.YEAR); //mostrarem els esdeveniments de l'any en curs
		
		calendariView = (GridView) rootView.findViewById(R.id.calendari);
		
		esdevenimentsView = (ListView) rootView.findViewById(R.id.esdeveniments_dia);
		
		titol_dia = (TextView) rootView.findViewById(R.id.titol_data);
		titol_dia.setText(getActivity().getResources().getString(R.string.text_titol_horari_agenda));
				
		// Inicialitzem l'adapter pel calendari
		try {
			adapter = new GridViewCalendariAdapter(getActivity(), this, R.id.dia_calendari, mes, any);
			calendariView.setAdapter(adapter);
		} catch (ParseException e) {
			Toast.makeText(getActivity(), "Impossible preparar el calendari", Toast.LENGTH_LONG).show();
		}
		
		return rootView;
	}
	
	// funció mostra els esdeveniments del dia seleccionat
	// comunica l'adapter amb el fragment
	public void mostrarEsdevenimentsDia(List<ItemLlistaAgenda> llista, String data) {
		titol_dia.setText(getActivity().getResources().getString(R.string.text_titol_horari_agenda) + ": " + data);
		esdevenimentsView.setAdapter(new LlistaAgendaAdapter(getActivity(), R.layout.list_item_agenda, llista, false));
	}
	
	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		
		outState.putAll(outState);
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
	}
}