package net.bonotown.android.aravadebo;

import java.util.ArrayList;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.adapter.LlistaGestioAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaGestio;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.Toast;

public class FragmentGestio extends Fragment {

	private ListView llista_gestio;
	private String[] titols_items_gestio;
	private ArrayList<ItemLlistaGestio> items_gestio;
	private LlistaGestioAdapter adapter;
	
	public FragmentGestio() {}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		View rootView = inflater.inflate(R.layout.fragment_gestio, container, false);
		
		llista_gestio = (ListView) rootView.findViewById(R.id.llista_gestio);
		
		items_gestio = new ArrayList<ItemLlistaGestio>();
		
		titols_items_gestio = getResources().getStringArray(R.array.items_gestio);
		
		for (String titolItem : titols_items_gestio) {
			items_gestio.add(new ItemLlistaGestio(titolItem));
		}
		
		adapter = new LlistaGestioAdapter(getActivity(), R.layout.list_item_gestio, items_gestio);
		
		llista_gestio.setAdapter(adapter);
		
		llista_gestio.setOnItemClickListener(new ItemGestioClickListener());
		
		return rootView;
	}
	
	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		
		outState.putAll(outState);
	}
	
	private class ItemGestioClickListener implements ListView.OnItemClickListener {
		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

			Intent intent = new Intent();

			switch (position) {
			case 0:
				intent.setClass(getActivity(), GestioUbicacionsActivity.class);
				break;
			case 1:
				intent.setClass(getActivity(), GestioAgendaActivity.class);
				break;
			case 2:
				intent.setClass(getActivity(), GestioHistoriaActivity.class);
				break;
			default:
				intent = null;
				break;
			}

			if (intent!=null) {
				startActivity(intent);
			} else{
				Log.i(Activity.ACTIVITY_SERVICE, "No s'ha pogut obrir la gestió");
				Toast.makeText(getActivity(), "No s'ha pogut obrir la gestió", Toast.LENGTH_LONG).show();
			}
		}
	}
}
