package net.bonotown.android.aravadebo;

import java.util.List;

import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.ParseQuery;

import net.bonotown.android.aravadebo.adapter.LlistaHistoriaAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaHistoria;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

public class FragmentHistoria extends Fragment {
	//definicio de variable globals de la classe
	private ListView listViewApartats;

	protected LlistaHistoriaAdapter adapter;

	// constructor del fragment
	public FragmentHistoria() {}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

		View rootView = inflater.inflate(R.layout.fragment_historia, container, false);

		listViewApartats = (ListView) rootView.findViewById(R.id.llista_historia);

		if ((savedInstanceState != null) && (savedInstanceState.getParcelable("listViewApartats") != null)) {
			listViewApartats = (ListView) savedInstanceState.getParcelable("listViewApartats");
		} else {
			omplirLlistaApartatsHistoria();
		}

		return rootView;
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		
	}
	
	private void omplirLlistaApartatsHistoria() {
		//Cerquem tots els apartats segons el seu ordre
		ParseQuery<ItemLlistaHistoria> query = ItemLlistaHistoria.getQuery();
		query.orderByAscending("ordre");
		query.findInBackground(new FindCallback<ItemLlistaHistoria>() {

			@Override
			public void done(List<ItemLlistaHistoria> llista_apartats_historia, ParseException e) {
				if (e==null) {
					if (llista_apartats_historia.size()>0) {
						adapter = new LlistaHistoriaAdapter(getActivity(), R.layout.list_item_historia, llista_apartats_historia, false);

						listViewApartats.setAdapter(adapter);
					}
				}

			}
		});
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
	}
}