package net.bonotown.android.aravadebo;

import java.util.Calendar;
import java.util.List;

import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.SaveCallback;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.adapter.LlistaAgendaAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaAgenda;
import net.bonotown.android.aravadebo.validators.EditTextValidator;
import net.bonotown.android.aravadebo.validators.TextViewValidator;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.GridView;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.TimePicker;

public class GestioAgendaActivity extends Activity implements OnClickListener {

	private static final String SPLITTER_DATA = "/";
	private static final String SPLITTER_HORA = ".";

	private static final int ID_DIALEG_DATA = 0;
	private static final int ID_DIALEG_HORA = 1;

	private GridView listview;
	private EditText titolView;
	private EditText descripcioView;
	private TextView dataView;
	private TextView horaView;
	private ImageButton boto_data;
	private ImageButton boto_hora;

	protected LlistaAgendaAdapter adapter;
	protected boolean estaCreant = false;
	protected boolean hihaErrors = false;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gestio_agenda);

		listview = (GridView) findViewById(R.id.llista_agenda);

		titolView = (EditText) findViewById(R.id.camp_titol_agenda);
		titolView.addTextChangedListener(new EditTextValidator(titolView) {

			@Override
			public void validate(EditText editText, String text) {
				hihaErrors = (editText.getText().toString().compareTo("")==0);
				if(hihaErrors)
					editText.setError("Cal indicar un títol");
			}
		});

		descripcioView = (EditText) findViewById(R.id.camp_descripcio_agenda);
		descripcioView.addTextChangedListener(new EditTextValidator(descripcioView) {

			@Override
			public void validate(EditText editText, String text) {
				hihaErrors = (editText.getText().toString().compareTo("")==0);
				if(hihaErrors)
					editText.setError("Cal introduir una descripció");

			}
		});

		dataView = (TextView) findViewById(R.id.text_data_esdeveniment);
		dataView.addTextChangedListener(new TextViewValidator(dataView) {

			@Override
			public void validate(TextView textView, String text) {
				hihaErrors = (textView.getText().toString().compareTo("")==0);
				if(hihaErrors)
					textView.setError("Cal seleccionar una data");
			}
		});

		horaView = (TextView) findViewById(R.id.text_hora_esdeveniment);
		horaView.addTextChangedListener(new TextViewValidator(dataView) {

			@Override
			public void validate(TextView textView, String text) {
				hihaErrors = (textView.getText().toString().compareTo("")==0);
				if(hihaErrors)
					textView.setError("Cal indicar una hora");
			}
		});

		boto_data = (ImageButton) findViewById(R.id.boto_data);
		boto_data.setOnClickListener(this);
		boto_data.setEnabled(estaCreant);

		boto_hora = (ImageButton) findViewById(R.id.boto_hora);
		boto_hora.setOnClickListener(this);
		boto_hora.setEnabled(estaCreant);

		// boto per crear nou esdeveniment
		Button button = (Button) findViewById(R.id.nou_esdeveniment);
		button.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if (! estaCreant) {
					estaCreant = true;
					titolView.setText("");
					descripcioView.setText("");
					dataView.setText("");
					horaView.setText("");

				} else {
					if (! hihaErrors) {
						estaCreant = false;

						ItemLlistaAgenda itemCreat = new ItemLlistaAgenda();
						itemCreat.setTitol(titolView.getText().toString());
						itemCreat.setDescripcio(descripcioView.getText().toString());
						itemCreat.setData(dataView.getText().toString());
						itemCreat.setHora(horaView.getText().toString());

						itemCreat.getACL().setPublicReadAccess(true);
						itemCreat.getACL().setPublicWriteAccess(false);

						itemCreat.saveInBackground(new SaveCallback() {

							@Override
							public void done(ParseException e) {
								omplirLlistaAgenda();
							}
						});
					}
				}

				titolView.setEnabled(estaCreant);
				descripcioView.setEnabled(estaCreant);
				dataView.setEnabled(estaCreant);
				boto_data.setClickable(estaCreant);
				boto_data.setEnabled(estaCreant);
				horaView.setEnabled(estaCreant);
				boto_hora.setClickable(estaCreant);
				boto_hora.setEnabled(estaCreant);
			}
		});

		// boto per editar esdeveniment
		//		button = (Button) findViewById(R.id.edita_esdeveniment);
		//		button.setOnClickListener(new View.OnClickListener() {
		//			@Override
		//			public void onClick(View v) {
		//				if (! estaCreant) {
		//					if (objectIdView.getText().toString().compareTo("")==0) {
		//						estaCreant = true;
		//						Toast.makeText(context, "Has de seleccionar un esdeveniment", Toast.LENGTH_SHORT).show();
		//					}
		//				} else {
		//					if (! hihaErrors) {
		//						estaCreant = false;
		//						
		//						ParseQuery<ItemLlistaAgenda> query = ItemLlistaAgenda.getQuery(); 
		//						query.whereEqualTo("objectId", objectIdView.getText().toString());
		//						query.getFirstInBackground(new GetCallback<ItemLlistaAgenda>() {
		//							
		//							@Override
		//							public void done(ItemLlistaAgenda itemSel, ParseException e) {
		//								if (e==null) {
		//									itemSel.setTitol(titolView.getText().toString());
		//									itemSel.setDescripcio(descripcioView.getText().toString());
		//									itemSel.setData(dataView.getText().toString());
		//									itemSel.setHora(horaView.getText().toString());
		//									itemSel.saveInBackground(new SaveCallback() {
		//
		//										@Override
		//										public void done(ParseException e) {
		//											omplirLlistaAgenda();
		//										}
		//									});
		//								}
		//							}
		//						});						
		//					}
		//				}
		//				
		//				titolView.setEnabled(estaCreant);
		//				descripcioView.setEnabled(estaCreant);
		//				dataView.setEnabled(estaCreant);
		//				boto_calendari.setClickable(estaCreant);
		//				boto_calendari.setEnabled(estaCreant);
		//				horaView.setEnabled(estaCreant);
		//				boto_horari.setClickable(estaCreant);
		//				boto_horari.setEnabled(estaCreant);
		//			}
		//		});
	}

	@Override
	protected void onStart() {
		omplirLlistaAgenda();
		super.onStart();
	}



	// omplirà la llista amb els esdeveniments existents
	private void omplirLlistaAgenda() {
		ItemLlistaAgenda.getQuery().findInBackground(new FindCallback<ItemLlistaAgenda>() {

			@Override
			public void done(List<ItemLlistaAgenda> llista_esdeveniments, ParseException e) {
				if (e==null) {
					if (llista_esdeveniments.size()>0) {
						adapter = new LlistaAgendaAdapter(GestioAgendaActivity.this, R.layout.list_item_agenda, llista_esdeveniments, true);
						listview.setAdapter(adapter);
					}
				} else {
					Log.e(GestioAgendaActivity.class.getName(), "Error durant la càrrega dels esdeveniments - " + e.getMessage());
					finish();
				}
			}
		});
	}

	@Override
	@Deprecated
	protected Dialog onCreateDialog(int id) {
		Calendar cal = Calendar.getInstance();

		switch (id) {
		case ID_DIALEG_DATA:

			int dia = cal.get(Calendar.DAY_OF_MONTH);
			int mes = cal.get(Calendar.MONTH);
			int any = cal.get(Calendar.YEAR);

			return new DatePickerDialog(this, datePickerListener, any, mes, dia);

		case ID_DIALEG_HORA:

			int hora = cal.get(Calendar.HOUR_OF_DAY);
			int minuts = cal.get(Calendar.MINUTE);

			return new TimePickerDialog(this, timePickerListener, hora, minuts, true);

		default:
			return null;
		}

	}

	private DatePickerDialog.OnDateSetListener datePickerListener = new DatePickerDialog.OnDateSetListener() {

		@Override
		public void onDateSet(DatePicker view, int selectedYear, int selectedMonth, int selectedDay) {
			dataView.setText(selectedDay + SPLITTER_DATA  + (selectedMonth + 1) + SPLITTER_DATA + selectedYear);
		}
	};

	private TimePickerDialog.OnTimeSetListener timePickerListener = new TimePickerDialog.OnTimeSetListener() {

		@Override
		public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
			horaView.setText(Integer.toString(hourOfDay) + SPLITTER_HORA + Integer.toString(minute) + "h");
		}
	};

	@Override
	@Deprecated
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.boto_data:
			showDialog(ID_DIALEG_DATA);
			break;
		case R.id.boto_hora:
		default:
			showDialog(ID_DIALEG_HORA);
			break;
		}
	}
}
