package net.bonotown.android.aravadebo;

import java.util.List;

import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.SaveCallback;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.adapter.LlistaHistoriaAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaHistoria;
import net.bonotown.android.aravadebo.validators.EditTextValidator;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.GridView;

public class GestioHistoriaActivity extends Activity implements OnClickListener {

	// Declaració variables
	private GridView listView;
	private EditText titolView;
	private EditText descripcioView;

	protected LlistaHistoriaAdapter adapter;
	protected boolean estaCreant = false;
	protected boolean hihaErrors = false;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gestio_historia);

		listView = (GridView) findViewById(R.id.llista_historia);
		
		titolView = (EditText) findViewById(R.id.camp_titol_historia);
		titolView.addTextChangedListener(new EditTextValidator(titolView) {

			@Override
			public void validate(EditText editText, String text) {
				hihaErrors = (editText.getText().toString().compareTo("")==0);
				if(hihaErrors)
					editText.setError("Cal indicar un títol");
			}
		});

		descripcioView = (EditText) findViewById(R.id.camp_descripcio_historia);
		descripcioView.addTextChangedListener(new EditTextValidator(descripcioView) {

			@Override
			public void validate(EditText editText, String text) {
				hihaErrors = (editText.getText().toString().compareTo("")==0);
				if(hihaErrors)
					editText.setError("Cal introduir una descripció");

			}
		});

		Button button = (Button) findViewById(R.id.nou_apartat);
		button.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if (! estaCreant) {
					estaCreant = true;
					titolView.setText("");
					descripcioView.setText("");

				} else {
					if (! hihaErrors) {
						estaCreant = false;

						ItemLlistaHistoria itemCreat = new ItemLlistaHistoria();
						itemCreat.setTitol(titolView.getText().toString());
						itemCreat.setDescripcio(descripcioView.getText().toString());

						itemCreat.getACL().setPublicReadAccess(true);
						itemCreat.getACL().setPublicWriteAccess(false);

						itemCreat.saveInBackground(new SaveCallback() {

							@Override
							public void done(ParseException e) {
								if (e==null) {
									omplirLlistaApartats();
								}
							}
						});
					}
				}

				titolView.setEnabled(estaCreant);
				descripcioView.setEnabled(estaCreant);

			}
		});
	}

	@Override
	protected void onStart() {
		omplirLlistaApartats();
		super.onStart();
	}

	private void omplirLlistaApartats() {
		ItemLlistaHistoria.getQuery().findInBackground(new FindCallback<ItemLlistaHistoria>() {

			@Override
			public void done(List<ItemLlistaHistoria> llista_apartats_historia, ParseException e) {
				if (e==null) {
					if (llista_apartats_historia.size()>0) {
						adapter = new LlistaHistoriaAdapter(GestioHistoriaActivity.this, R.layout.list_item_historia, llista_apartats_historia, true);
						listView.setAdapter(adapter);
					}
				}
			}
		});
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		
	}	
}
