package net.bonotown.android.aravadebo;

import java.util.List;

import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.SaveCallback;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.adapter.LlistaUbicacioAdapter;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaUbicacio;
import net.bonotown.android.aravadebo.validators.EditTextValidator;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.GridView;

public class GestioUbicacionsActivity extends Activity implements OnClickListener, OnItemClickListener {

	// Declaració variables
	private GridView listview;
	private EditText nom;
	private EditText latitud;
	private EditText longitud;
	
	protected LlistaUbicacioAdapter adapter;
	protected boolean estaCreant = false;
	protected boolean hihaErrors = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gestio_ubicacions);

		try {
			omplirLlistaUbicacions();

			nom = (EditText) findViewById(R.id.nom_ubicacio);
			nom.addTextChangedListener(new EditTextValidator(nom) {

				@Override
				public void validate(EditText editText, String text) {
					hihaErrors = (editText.getText().toString().compareTo("")==0);
					if(hihaErrors)
						editText.setError("Es requereix un nom per la ubicació");
				}
			});

			latitud = (EditText) findViewById(R.id.latitud_ubicacio);
			latitud.addTextChangedListener(new EditTextValidator(latitud) {

				@Override
				public void validate(EditText editText, String text) {
					hihaErrors = (editText.getText().toString().compareTo("")==0);
					if(hihaErrors)
						editText.setError("Es requereix la latitud de la ubicació");

				}
			});

			longitud = (EditText) findViewById(R.id.longitud_ubicacio);
			longitud.addTextChangedListener(new EditTextValidator(latitud) {

				@Override
				public void validate(EditText editText, String text) {
					hihaErrors = (editText.getText().toString().compareTo("")==0);
					if(hihaErrors)
						editText.setError("Es requereix la longitud de la ubicació");
				}
			});

			Button button = (Button) findViewById(R.id.nova_ubicacio);
			button.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					if (! estaCreant) {
						estaCreant = true;
						nom.setText("");
						latitud.setText("");  
						longitud.setText("");
					} else {
						if (! hihaErrors) {
							estaCreant = false;

							ItemLlistaUbicacio itemCreat = new ItemLlistaUbicacio();
							itemCreat.setNom(nom.getText().toString());
							itemCreat.setLatitude(Double.parseDouble(latitud.getText().toString()));
							itemCreat.setLongitude(Double.parseDouble(longitud.getText().toString()));
														
							itemCreat.getACL().setPublicReadAccess(true);
							itemCreat.getACL().setPublicWriteAccess(false);
							
							itemCreat.saveInBackground(new SaveCallback() {

								@Override
								public void done(ParseException e) {
									try {
										omplirLlistaUbicacions();
									} catch (ParseException e1) {
										e1.printStackTrace();
									} catch (InstantiationException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									} catch (IllegalAccessException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
								}
							});
						}
					}

					nom.setEnabled(estaCreant);
					latitud.setEnabled(estaCreant);
					longitud.setEnabled(estaCreant);

				}
			});

		} catch (ParseException e) {
			Log.e(GestioUbicacionsActivity.class.getName(), "Error durant la càrrega de les ubicacions");
			finish();
		} catch (InstantiationException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		} catch (IllegalAccessException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
	}

	private void omplirLlistaUbicacions() throws ParseException, InstantiationException, IllegalAccessException {
		ItemLlistaUbicacio.getQuery().findInBackground(new FindCallback<ItemLlistaUbicacio>() {
			
			@Override
			public void done(List<ItemLlistaUbicacio> llista_ubicacions, ParseException e) {
				if (e==null) {
					adapter = new LlistaUbicacioAdapter(GestioUbicacionsActivity.this, R.layout.list_item_ubicacio, llista_ubicacions, false);
					
					listview = (GridView) findViewById(R.id.llista_ubicacions);
					listview.setAdapter(adapter);
					
					listview.setOnItemClickListener(new OnItemClickListener() {
					
						@Override
						public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
							// TODO: Edició del contingut d'un item de la llista
						}
					});
				}
			}
		});
	}	

	@Override
	public void onClick(View v) {
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	}
}
