package net.bonotown.android.aravadebo;

import java.text.SimpleDateFormat;
import java.util.Date;

import com.parse.ParseException;
import com.parse.ParseFile;
import com.parse.ParseGeoPoint;
import com.parse.ParseUser;
import com.parse.SaveCallback;

import net.bonotown.android.aravadebo.model.PostFoto;
import android.app.Activity;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class PostFotoActivity extends Activity implements OnClickListener {

	//Declaració de variables a fer servir
	private PostFoto parseFotoPost;
	private double latitut;
	private double longitut;
	private byte[] imatgeBytes;
	private ParseFile fotoFile;
	private TextView text_imatge_post;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_post_foto);
		setupActionBar();

		ImageView imgView = (ImageView) findViewById(R.id.imatge_post);

		text_imatge_post = (TextView) findViewById(R.id.text_imatge_post);

		latitut = getIntent().getDoubleExtra("latitude", 40.0010061);
		longitut = getIntent().getDoubleExtra("longitude", 3.8365123);

		if (getIntent().hasExtra("foto")) {
			//recuperem el bytes per desar a parse.com
			imatgeBytes = getIntent().getByteArrayExtra("foto");

			//Mostrem un preview
			imgView.setImageBitmap(BitmapFactory.decodeByteArray(getIntent().getByteArrayExtra("foto"),0,getIntent().getByteArrayExtra("foto").length));

			// Afegim Listener al boto per desar la foto
			Button sendButton = (Button) findViewById(R.id.boto_enviar_imatge_post);
			sendButton.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());

					//Creem un objecte ParseFile per enviar la foto
					fotoFile = new ParseFile(ParseUser.getCurrentUser() + "_img_" + timeStamp + ".png", imatgeBytes);
					
					//desem en rerefons la foto a parse.com
					fotoFile.saveInBackground(new SaveCallback() {

						@Override
						public void done(ParseException e) {
							if (e==null) {
								//Creem el punt de coordenades on s'ha registrat la foto ParseGeoPoint
								ParseGeoPoint geoPoint = new ParseGeoPoint();
								geoPoint.setLatitude(latitut);
								geoPoint.setLongitude(longitut);

								//Objecte per emmagatzemar les fotos a parse.com
								parseFotoPost = new PostFoto();
								parseFotoPost.setLocation(geoPoint);
								parseFotoPost.setComentari(text_imatge_post.getText().toString());
								parseFotoPost.setUser(ParseUser.getCurrentUser());
								parseFotoPost.setFoto(fotoFile);

								// Desem el post amb imatge i comentari
								parseFotoPost.saveInBackground(new SaveCallback() {
									@Override
									public void done(ParseException e) {
										if (e==null) {
											setResult(RESULT_OK);
											Toast.makeText(PostFotoActivity.this, "Foto desada correctament", Toast.LENGTH_SHORT).show();
										} else {
											setResult(RESULT_CANCELED);
											Log.e(PostVideoActivity.class.getName(), "Problemes en desar la foto - " + e.getMessage());
										}
									}
								});
							} else {
								setResult(RESULT_CANCELED);
								Log.e(PostVideoActivity.class.getName(), "Problemes en desar la foto - " + e.getMessage());
							}

						}
					});
					
					finish();
				}
			});

		} else {
			setResult(RESULT_CANCELED);
			Log.e(PostVideoActivity.class.getName(), "Problemes en recuperar la foto de la càmera");
			finish();
		}
	}

	/**
	 * Set up the {@link android.app.ActionBar}.
	 */
	private void setupActionBar() {
		getActionBar().setDisplayHomeAsUpEnabled(true);
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		//getMenuInflater().inflate(R.menu.post_foto, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub

	}
}