package net.bonotown.android.aravadebo;

import com.parse.ParseException;
import com.parse.ParseGeoPoint;
import com.parse.ParseUser;
import com.parse.SaveCallback;

import net.bonotown.android.aravadebo.model.PostText;
import android.app.Activity;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class PostTextActivity extends Activity implements OnClickListener {

	//Declaració de variables a fer servir
	private PostText parseTextPost;
	private double latitut;
	private double longitut;
	private TextView text_post;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_post_comentari);
		setupActionBar();
		
		text_post = (TextView) findViewById(R.id.text_comentari_post);

		latitut = getIntent().getDoubleExtra("latitude", 40.0010061);
		longitut = getIntent().getDoubleExtra("longitude", 3.8365123);

		// Afegim Listener al boto per desar la foto
		Button sendButton = (Button) findViewById(R.id.boto_enviar_comentari_post);
		sendButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				//Creem el punt de coordenades on s'ha registrat la foto ParseGeoPoint
				ParseGeoPoint geoPoint = new ParseGeoPoint();
				geoPoint.setLatitude(latitut);
				geoPoint.setLongitude(longitut);

				//Objecte per emmagatzemar les fotos a parse.com
				parseTextPost = new PostText();
				parseTextPost.setLocation(geoPoint);
				parseTextPost.setComentari(text_post.getText().toString());
				parseTextPost.setUser(ParseUser.getCurrentUser());

				// Desem el post amb imatge i comentari
				parseTextPost.saveInBackground(new SaveCallback() {

					@Override
					public void done(ParseException e) {
						if (e==null) {
							setResult(RESULT_OK);
							Toast.makeText(PostTextActivity.this, "Comentari desat correctament", Toast.LENGTH_SHORT).show();
						} else {
							setResult(RESULT_CANCELED);
							Log.e(PostTextActivity.class.getName(), "Problemes en desar el comentari - " + e.getMessage());
						}
					}
				});

				finish();
			}
		});
	}

	/**
	 * Set up the {@link android.app.ActionBar}.
	 */
	private void setupActionBar() {
		getActionBar().setDisplayHomeAsUpEnabled(true);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		//getMenuInflater().inflate(R.menu.post_text, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub

	}
}