package net.bonotown.android.aravadebo.adapter;

import java.util.List;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaAgenda;
import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class LlistaAgendaAdapter extends ArrayAdapter<ItemLlistaAgenda> {

	private int resourceId;
	private boolean gestio;
	private Context context;
	private List<ItemLlistaAgenda> items_llista_esdeveniments;

	public LlistaAgendaAdapter(Context context, int resource, List<ItemLlistaAgenda> objects, boolean gestio) {
		super(context, resource, objects);

		this.resourceId = resource;
		this.context = context;
		this.gestio = gestio;
		this.items_llista_esdeveniments = objects;
	}

	/**
	 * @return the context
	 */
	public Context getContext() {
		return context;
	}

	/**
	 * @param context the context to set
	 */
	public void setContext(Context context) {
		this.context = context;
	}

	@Override
	public int getCount() {
		return items_llista_esdeveniments.size();
	}

	@Override
	public ItemLlistaAgenda getItem(int position) {
		return items_llista_esdeveniments.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {

		ItemLlistaAgenda esdeveniment = new ItemLlistaAgenda();

		if (convertView == null) {
			LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
			convertView = mInflater.inflate(resourceId, null);

			convertView.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					// Quan cliquem en un dels ítems de la llista és desplegarà la descripció

					LinearLayout campsLayout = (LinearLayout) v.findViewById(R.id.camps_esdeveniments_llista);
					TextView textView = (TextView) v.findViewById(R.id.descripcio_item_agenda);
					ImageView imageView = (ImageView) v.findViewById(R.id.veure_descripcio_agenda);

					textView.clearAnimation();
					if (textView.getVisibility()==View.GONE){
						textView.setVisibility(View.VISIBLE);
						campsLayout.setBackgroundColor(context.getResources().getColor(R.color.darkorrange));
						imageView.setImageDrawable(context.getResources().getDrawable(R.drawable.plegar));
						Animation animation = AnimationUtils.loadAnimation(context, R.anim.textview_obrir_lliscant);
						textView.setAnimation(animation);
					} else {
						campsLayout.setBackgroundColor(context.getResources().getColor(R.color.black));
						imageView.setImageDrawable(context.getResources().getDrawable(R.drawable.desplegar));
						textView.setVisibility(View.GONE);
					}
				}
			});

			esdeveniment.id_item_agenda = (TextView) convertView.findViewById(R.id.id_item_agenda);
			esdeveniment.seleccio_agenda = (CheckBox)convertView.findViewById(R.id.item_agenda_seleccionat);
			esdeveniment.data_agenda = (TextView) convertView.findViewById(R.id.data_item_agenda);

			if (! gestio) {
				esdeveniment.data_agenda.setVisibility(View.GONE);
				esdeveniment.seleccio_agenda.setVisibility(View.GONE);
			}

			esdeveniment.hora_agenda = (TextView) convertView.findViewById(R.id.hora_item_agenda);
			esdeveniment.titol_agenda = (TextView) convertView.findViewById(R.id.titol_item_agenda);
			esdeveniment.descripcio_agenda = (TextView) convertView.findViewById(R.id.descripcio_item_agenda);

			convertView.setTag(esdeveniment);
		} else {
			esdeveniment = (ItemLlistaAgenda) convertView.getTag();
		}

		ItemLlistaAgenda esdevenimentActual = items_llista_esdeveniments.get(position);
		esdeveniment.id_item_agenda.setText(esdevenimentActual.getId());
		esdeveniment.seleccio_agenda.setChecked(false);
		esdeveniment.data_agenda.setText(esdevenimentActual.getData());
		esdeveniment.hora_agenda.setText(esdevenimentActual.getHora());
		esdeveniment.titol_agenda.setText(esdevenimentActual.getTitol());
		esdeveniment.descripcio_agenda.setText(esdevenimentActual.getDescripcio());

		return convertView;

	}
}