package net.bonotown.android.aravadebo.adapter;

import java.util.ArrayList;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaGestio;
import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class LlistaGestioAdapter extends ArrayAdapter<ItemLlistaGestio> {

	private int resourceId;
	private Context context;
	private ArrayList<ItemLlistaGestio> items_llista_ubicacio;

	public LlistaGestioAdapter(Context context, int resource, ArrayList<ItemLlistaGestio> objects) {
		super(context, resource, objects);
		
		this.resourceId = resource;
		this.context = context;
		this.items_llista_ubicacio = objects;
	}
	
	/**
	 * @return the context
	 */
	public Context getContext() {
		return context;
	}

	/**
	 * @param context the context to set
	 */
	public void setContext(Context context) {
		this.context = context;
	}

	@Override
	public int getCount() {
		return items_llista_ubicacio.size();
	}

	@Override
	public ItemLlistaGestio getItem(int position) {
		return items_llista_ubicacio.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View row = convertView;
		ItemLlistaGestio item = null;
		
		if (row == null) {
			LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
			row = mInflater.inflate(resourceId, null);
			
			item = new ItemLlistaGestio();
			item.titol = (TextView) row.findViewById(R.id.titol);
			
			row.setTag(item);
		} else {
			item = (ItemLlistaGestio) row.getTag();
		}
		
		ItemLlistaGestio itemActual = items_llista_ubicacio.get(position);
		item.titol.setText(itemActual.getTitle());
		
		return row;
		
	}
}