package net.bonotown.android.aravadebo.adapter;

import java.util.List;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaHistoria;
import android.app.Activity;
import android.content.Context;
import android.text.method.ScrollingMovementMethod;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class LlistaHistoriaAdapter extends ArrayAdapter<ItemLlistaHistoria> {

	private int resourceId;
	private boolean gestio;
	private Context context;
	private List<ItemLlistaHistoria> items_llista_apartats;

	public LlistaHistoriaAdapter(Context context, int resource, List<ItemLlistaHistoria> objects, boolean gestio) {
		super(context, resource, objects);

		this.resourceId = resource;
		this.gestio = gestio;
		this.context = context;
		this.items_llista_apartats = objects;
	}

	/**
	 * @return the context
	 */
	public Context getContext() {
		return context;
	}

	/**
	 * @param context the context to set
	 */
	public void setContext(Context context) {
		this.context = context;
	}

	@Override
	public int getCount() {
		return items_llista_apartats.size();
	}

	@Override
	public ItemLlistaHistoria getItem(int position) {
		return items_llista_apartats.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {

		ItemLlistaHistoria apartat = new ItemLlistaHistoria();

		if (convertView == null) {
			LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
			convertView = mInflater.inflate(resourceId, null);

			convertView.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					// Quan cliquem en un dels ítems de la llista és desplegarà la descripció

					LinearLayout campsLayout = (LinearLayout) v.findViewById(R.id.camps_apartat_llista);
					TextView textView = (TextView) v.findViewById(R.id.descripcio_item_historia);
					ImageView imageView = (ImageView) v.findViewById(R.id.veure_descripcio_historia);

					textView.clearAnimation();
					if (textView.getVisibility()==View.GONE){
						textView.setVisibility(View.VISIBLE);
						campsLayout.setBackgroundColor(context.getResources().getColor(R.color.darkorrange));
						
						imageView.setImageDrawable(context.getResources().getDrawable(R.drawable.plegar));
						Animation animation = AnimationUtils.loadAnimation(context, R.anim.textview_obrir_lliscant);
						textView.setAnimation(animation);
					} else {
						imageView.setImageDrawable(context.getResources().getDrawable(R.drawable.desplegar));
						campsLayout.setBackgroundColor(context.getResources().getColor(R.color.black));
						textView.setVisibility(View.GONE);
					}
				}
			});

			apartat.id_item_historia = (TextView) convertView.findViewById(R.id.id_item_historia);
			apartat.seleccio_historia = (CheckBox) convertView.findViewById(R.id.item_historia_seleccionat);
			apartat.titol_historia = (TextView) convertView.findViewById(R.id.titol_item_historia);
			apartat.descripcio_historia = (TextView) convertView.findViewById(R.id.descripcio_item_historia);
			
			

			if (! gestio) {
				apartat.seleccio_historia.setVisibility(View.GONE);
			}

			convertView.setTag(apartat);
		} else {
			apartat = (ItemLlistaHistoria) convertView.getTag();
		}

		ItemLlistaHistoria apartatActual = items_llista_apartats.get(position);
		apartat.id_item_historia.setText(apartatActual.getId());
		apartat.seleccio_historia.setChecked(false);
		apartat.titol_historia.setText(apartatActual.getTitol());
		
		apartat.descripcio_historia.setMovementMethod(new ScrollingMovementMethod());
		
		apartat.descripcio_historia.setText(apartatActual.getDescripcio());

		return convertView;

	}
}