package net.bonotown.android.aravadebo.adapter;

import java.util.List;

import net.bonotown.android.aravadebo.R;
import net.bonotown.android.aravadebo.model.gestio.ItemLlistaUbicacio;
import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.TextView;

public class LlistaUbicacioAdapter extends ArrayAdapter<ItemLlistaUbicacio> {

	private int resourceId;
	private boolean esActivitatPrincipal = false;
	private Context context;
	private List<ItemLlistaUbicacio> items_llista_ubicacio;

	public LlistaUbicacioAdapter(Context context, int resource, List<ItemLlistaUbicacio> objects, boolean isMain) {
		super(context, resource, objects);
		
		this.resourceId = resource;
		this.esActivitatPrincipal = isMain;
		this.context = context;
		this.items_llista_ubicacio = objects;
	}
	
	/**
	 * @return the context
	 */
	public Context getContext() {
		return context;
	}

	/**
	 * @param context the context to set
	 */
	public void setContext(Context context) {
		this.context = context;
	}

	@Override
	public int getCount() {
		return items_llista_ubicacio.size();
	}

	@Override
	public ItemLlistaUbicacio getItem(int position) {
		return items_llista_ubicacio.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View row = convertView;
		ItemLlistaUbicacio ubicacio = null;
		
		if (row == null) {
			LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
			row = mInflater.inflate(resourceId, null);
			
			ubicacio = new ItemLlistaUbicacio();
			
			ubicacio.nom = (TextView) row.findViewById(R.id.nom);
			ubicacio.latitud = (TextView) row.findViewById(R.id.latitut);
			ubicacio.longitud = (TextView) row.findViewById(R.id.longitut);
			
			if (esActivitatPrincipal) {
				((CheckBox) row.findViewById(R.id.item_ubicacio_seleccionat)).setChecked(false);
				((TextView) row.findViewById(R.id.latitut)).setVisibility(View.INVISIBLE);
				((TextView) row.findViewById(R.id.longitut)).setVisibility(View.INVISIBLE);
			}
			
			row.setTag(ubicacio);
		} else {
			ubicacio = (ItemLlistaUbicacio) row.getTag();
		}
		
		ItemLlistaUbicacio ubicacioActual = items_llista_ubicacio.get(position);
		ubicacio.nom.setText(ubicacioActual.getNom());
		ubicacio.latitud.setText(Double.toString(ubicacioActual.getLatitude()));
		ubicacio.longitud.setText(Double.toString(ubicacioActual.getLongitude()));
		
		return row;
		
	}
}